<html>
<head>
<title>Memory - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#namespaces">Namespaces</a> &#124;
<a href="#files">Files</a> &#124;
<a href="#define-members">Defines</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Memory</div>  </div>
<div class="ingroups"><a class="el" href="group__Core.html">Core</a></div></div><!--header-->
<div class="contents">
<div class="dynheader">
Collaboration diagram for Memory:</div>
<div class="dyncontent">
<center><table><tr><td><img src="group__Memory.gif" border="0" alt="" usemap="#group____Memory"/>
<map name="group____Memory" id="group____Memory">
<area shape="rect" id="node1" href="group__Core.html" title="Core" alt="" coords="5,5,56,35"/></map>
</td></tr></table></center>
</div>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AlignedMemory.html">Ogre::AlignedMemory</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class to provide aligned memory allocate functionality.  <a href="classOgre_1_1AlignedMemory.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject&lt; Alloc &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Superclass for all objects that wish to use custom memory allocators when their new / delete operators are called.  <a href="classOgre_1_1AllocatedObject.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedAllocImpl.html">Ogre::NedAllocImpl</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Non-templated utility class just to hide nedmalloc.  <a href="classOgre_1_1NedAllocImpl.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedAllocPolicy.html">Ogre::NedAllocPolicy</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>.  <a href="classOgre_1_1NedAllocPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedAlignedAllocPolicy.html">Ogre::NedAlignedAllocPolicy&lt; Alignment &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>, which aligns memory at a given boundary (which should be a power of 2).  <a href="classOgre_1_1NedAlignedAllocPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedPoolingImpl.html">Ogre::NedPoolingImpl</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Non-templated utility class just to hide nedmalloc.  <a href="classOgre_1_1NedPoolingImpl.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedPoolingPolicy.html">Ogre::NedPoolingPolicy</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>.  <a href="classOgre_1_1NedPoolingPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NedPoolingAlignedPolicy.html">Ogre::NedPoolingAlignedPolicy&lt; Alignment &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>, which aligns memory at a given boundary (which should be a power of 2).  <a href="classOgre_1_1NedPoolingAlignedPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StdAllocPolicy.html">Ogre::StdAllocPolicy</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A "standard" allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>.  <a href="classOgre_1_1StdAllocPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StdAlignedAllocPolicy.html">Ogre::StdAlignedAllocPolicy&lt; Alignment &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A "standard" allocation policy for use with <a class="el" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AllocatedObject</a> and <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>, which aligns memory at a given boundary (which should be a power of 2).  <a href="classOgre_1_1StdAlignedAllocPolicy.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1STLAllocatorBase.html">Ogre::STLAllocatorBase&lt; T &gt;</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Wrapper class for operating as an STL container allocator.  <a href="structOgre_1_1STLAllocatorBase.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1STLAllocatorBase_3_01const_01T_01_4.html">Ogre::STLAllocatorBase&lt; const T &gt;</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1STLAllocator.html">Ogre::STLAllocator&lt; T, AllocPolicy &gt;</a></td></tr>
<tr><td colspan="2"><h2><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">namespace &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html">Ogre</a></td></tr>
<tr><td colspan="2"><h2><a name="files"></a>
Files</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">file &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="OgreMemoryAllocatorConfig_8h.html">OgreMemoryAllocatorConfig.h</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight"><p>This file configures <a class="el" href="namespaceOgre.html">Ogre</a>'s memory allocators. </p>
<br/></td></tr>
<tr><td colspan="2"><h2><a name="define-members"></a>
Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga2382b731c3d757f74f0fedf2b14ed9d6">OGRE_MALLOC</a>(bytes, category)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(bytes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of raw memory, and indicate the category of usage.  <a href="#ga2382b731c3d757f74f0fedf2b14ed9d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga3211e4a6a806aa789b38dce2432ef472">OGRE_ALLOC_T</a>(T, count, category)&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for a primitive type, and indicate the category of usage.  <a href="#ga3211e4a6a806aa789b38dce2432ef472"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf">OGRE_FREE</a>(ptr, category)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to ensure the matching policy is used.  <a href="#gacfd8dc937cf390c7bff05495f0dc10cf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga46253f12658ce0922e982a8a9dd11312">OGRE_NEW_T</a>(T, category)&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T))) T</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate space for one primitive type, external type or non-virtual type with constructor parameters.  <a href="#ga46253f12658ce0922e982a8a9dd11312"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga6c428bbdad197df6a4ba22d3c1d48f5a">OGRE_NEW_ARRAY_T</a>(T, count, category)&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for 'count' primitive types - do not use for classes that inherit from AllocatedObject.  <a href="#ga6c428bbdad197df6a4ba22d3c1d48f5a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga0b0974da65362dd8a14071e7f6e4daca">OGRE_DELETE_T</a>(ptr, T, category)&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_T. Category is required to be restated to ensure the matching policy is used.  <a href="#ga0b0974da65362dd8a14071e7f6e4daca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gab9f9fa14d424036dc5881cbcb3c741e0">OGRE_DELETE_ARRAY_T</a>(ptr, T, count, category)&#160;&#160;&#160;if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_ARRAY_T. Category is required to be restated to ensure the matching policy is used, count and type to call destructor.  <a href="#gab9f9fa14d424036dc5881cbcb3c741e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gafd7ddaef10ac9ea1ffbd18902167b9a2">OGRE_MALLOC_SIMD</a>(bytes, category)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(bytes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of raw memory aligned to SIMD boundaries, and indicate the category of usage.  <a href="#gafd7ddaef10ac9ea1ffbd18902167b9a2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga876cf0a4c7e209ce798b5e6708ca2343">OGRE_MALLOC_ALIGN</a>(bytes, category, align)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(bytes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of raw memory aligned to user defined boundaries, and indicate the category of usage.  <a href="#ga876cf0a4c7e209ce798b5e6708ca2343"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga728b719dd1425d46a78fe87d6f9ea6a5">OGRE_ALLOC_T_SIMD</a>(T, count, category)&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for a primitive type aligned to SIMD boundaries, and indicate the category of usage.  <a href="#ga728b719dd1425d46a78fe87d6f9ea6a5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gafc79c14937612b02ac50631c08666b26">OGRE_ALLOC_T_ALIGN</a>(T, count, category, align)&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T)*(count)))</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for a primitive type aligned to user defined boundaries, and indicate the category of usage.  <a href="#gafc79c14937612b02ac50631c08666b26"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gaf7501eb098fc6671420c628dc80af2a8">OGRE_FREE_SIMD</a>(ptr, category)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with either OGRE_MALLOC_SIMD or OGRE_ALLOC_T_SIMD. Category is required to be restated to ensure the matching policy is used.  <a href="#gaf7501eb098fc6671420c628dc80af2a8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gaa06d37a211e3da357b8457ccdb4decac">OGRE_FREE_ALIGN</a>(ptr, category, align)&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with either OGRE_MALLOC_ALIGN or OGRE_ALLOC_T_ALIGN. Category is required to be restated to ensure the matching policy is used.  <a href="#gaa06d37a211e3da357b8457ccdb4decac"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga2f7eef98b7fe3ba9f36630b787d603b1">OGRE_NEW_T_SIMD</a>(T, category)&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T))) T</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate space for one primitive type, external type or non-virtual type aligned to SIMD boundaries.  <a href="#ga2f7eef98b7fe3ba9f36630b787d603b1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gaa55846bae98cf66fd5158ad0d4d623bb">OGRE_NEW_ARRAY_T_SIMD</a>(T, count, category)&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for 'count' primitive types aligned to SIMD boundaries - do not use for classes that inherit from AllocatedObject.  <a href="#gaa55846bae98cf66fd5158ad0d4d623bb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga1a5d598e538371f2fca9608277051347">OGRE_DELETE_T_SIMD</a>(ptr, T, category)&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_T_SIMD. Category is required to be restated to ensure the matching policy is used.  <a href="#ga1a5d598e538371f2fca9608277051347"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga3ceedc1e74432821ffab664232c12d04">OGRE_DELETE_ARRAY_T_SIMD</a>(ptr, T, count, category)&#160;&#160;&#160;if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_ARRAY_T_SIMD. Category is required to be restated to ensure the matching policy is used, count and type to call destructor.  <a href="#ga3ceedc1e74432821ffab664232c12d04"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga4c928813aac2c96ae5cc775aacd3e26d">OGRE_NEW_T_ALIGN</a>(T, category, align)&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T))) T</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate space for one primitive type, external type or non-virtual type aligned to user defined boundaries.  <a href="#ga4c928813aac2c96ae5cc775aacd3e26d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga51224b5c8af6fd85e192975ebe20139b">OGRE_NEW_ARRAY_T_ALIGN</a>(T, count, category, align)&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T)*(count))), count)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a block of memory for 'count' primitive types aligned to user defined boundaries - do not use for classes that inherit from AllocatedObject.  <a href="#ga51224b5c8af6fd85e192975ebe20139b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga076af127ea8efe2284e03ab4c2057603">OGRE_DELETE_T_ALIGN</a>(ptr, T, category, align)&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_T_ALIGN. Category is required to be restated to ensure the matching policy is used.  <a href="#ga076af127ea8efe2284e03ab4c2057603"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga25e1e9ce907fc367cc735465c940da23">OGRE_DELETE_ARRAY_T_ALIGN</a>(ptr, T, count, category, align)&#160;&#160;&#160;if(ptr){for (size_t _b = 0; _b &lt; count; ++_b) { (ptr)[_b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr);}</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Free the memory allocated with OGRE_NEW_ARRAY_T_ALIGN. Category is required to be restated to ensure the matching policy is used, count and type to call destructor.  <a href="#ga25e1e9ce907fc367cc735465c940da23"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a>&#160;&#160;&#160;new</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a>&#160;&#160;&#160;delete</td></tr>
<tr><td colspan="2"><h2><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga830fab51be174d6f2849857cb1abb36a">Ogre::MemoryCategory</a> { <br/>
&#160;&#160;<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb">Ogre::MEMCATEGORY_GENERAL</a> =  0, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e">Ogre::MEMCATEGORY_GEOMETRY</a> =  1, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa24267bedbd1115a8f208e4ee355693e4">Ogre::MEMCATEGORY_ANIMATION</a> =  2, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90">Ogre::MEMCATEGORY_SCENE_CONTROL</a> =  3, 
<br/>
&#160;&#160;<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaffe1e3d51d961175f8f2756611439181">Ogre::MEMCATEGORY_SCENE_OBJECTS</a> =  4, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa04bad2e7f64cc2b6f4cda9f56b59e5b4">Ogre::MEMCATEGORY_RESOURCE</a> =  5, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aaa037d2f843117cd5fb39ec064d7ff23b">Ogre::MEMCATEGORY_SCRIPTING</a> =  6, 
<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa29274489311d683a88676dbb1c779788">Ogre::MEMCATEGORY_RENDERSYS</a> =  7, 
<br/>
&#160;&#160;<a class="el" href="group__Memory.html#gga830fab51be174d6f2849857cb1abb36aa4ff2b9446477e2ea4170b09d8aaa1b67">Ogre::MEMCATEGORY_COUNT</a> =  8
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A set of categories that indicate the purpose of a chunk of memory being allocated.  <a href="group__Memory.html#ga830fab51be174d6f2849857cb1abb36a">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">T *&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a> (T *basePtr, size_t count)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Utility function for constructing an array of objects with placement new, without using new[] (which allocates an undocumented amount of extra memory and so isn't appropriate for custom allocators).  <a href="#gae542663b49eb68a74336d84e11ba0b9c"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T , typename T2 , typename P &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b">Ogre::operator==</a> (STLAllocator&lt; T, P &gt; const &amp;, STLAllocator&lt; T2, P &gt; const &amp;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">determine equality, can memory from another allocator be released by this allocator, (ISO C++)  <a href="#gaa5b83b2ba3ce965e3d8dd129c93ee43b"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T , typename P , typename OtherAllocator &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__Memory.html#gaa34a630f2287087875d360c454a0fb48">Ogre::operator==</a> (STLAllocator&lt; T, P &gt; const &amp;, OtherAllocator const &amp;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">determine equality, can memory from another allocator be released by this allocator, (ISO C++)  <a href="#gaa34a630f2287087875d360c454a0fb48"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T , typename T2 , typename P &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2">Ogre::operator!=</a> (STLAllocator&lt; T, P &gt; const &amp;, STLAllocator&lt; T2, P &gt; const &amp;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">determine equality, can memory from another allocator be released by this allocator, (ISO C++)  <a href="#ga34a9308dc656f694883718bf8fa4f1c2"></a><br/></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T , typename P , typename OtherAllocator &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group__Memory.html#ga0cec9339a4ab3eaf48c767087cd7f400">Ogre::operator!=</a> (STLAllocator&lt; T, P &gt; const &amp;, OtherAllocator const &amp;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">determine equality, can memory from another allocator be released by this allocator, (ISO C++)  <a href="#ga0cec9339a4ab3eaf48c767087cd7f400"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ga3211e4a6a806aa789b38dce2432ef472"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_ALLOC_T" ref="ga3211e4a6a806aa789b38dce2432ef472" args="(T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga3211e4a6a806aa789b38dce2432ef472">OGRE_ALLOC_T</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for a primitive type, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00426">426</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAxisAlignedBox_8h_source.html#l00302">Ogre::AxisAlignedBox::getAllCorners()</a>, <a class="el" href="OgreTerrain_8h_source.html#l00428">Ogre::Terrain::ImportData::operator=()</a>, <a class="el" href="OgreStreamSerialiser_8h_source.html#l00366">Ogre::StreamSerialiser::readConverted()</a>, <a class="el" href="OgreVertexIndexData_8h_source.html#l00291">Ogre::VertexCacheProfiler::VertexCacheProfiler()</a>, and <a class="el" href="OgreStreamSerialiser_8h_source.html#l00353">Ogre::StreamSerialiser::writeConverted()</a>.</p>

</div>
</div>
<a class="anchor" id="gafc79c14937612b02ac50631c08666b26"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_ALLOC_T_ALIGN" ref="gafc79c14937612b02ac50631c08666b26" args="(T, count, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gafc79c14937612b02ac50631c08666b26">OGRE_ALLOC_T_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T)*(count)))</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for a primitive type aligned to user defined boundaries, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00447">447</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga728b719dd1425d46a78fe87d6f9ea6a5"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_ALLOC_T_SIMD" ref="ga728b719dd1425d46a78fe87d6f9ea6a5" args="(T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga728b719dd1425d46a78fe87d6f9ea6a5">OGRE_ALLOC_T_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count)))</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for a primitive type aligned to SIMD boundaries, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00445">445</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gad18eff671a00617b21c8e35a7f545690"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE" ref="gad18eff671a00617b21c8e35a7f545690" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a>&#160;&#160;&#160;delete</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00472">472</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRenderQueueSortingGrouping_8h_source.html#l00557">Ogre::RenderQueueGroup::clear()</a>, <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00484">Ogre::deletePtr()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>, <a class="el" href="OgreTerrain_8h_source.html#l00470">Ogre::Terrain::ImportData::destroy()</a>, <a class="el" href="OgreZip_8h_source.html#l00122">Ogre::ZipArchiveFactory::destroyInstance()</a>, <a class="el" href="OgreSimplePageContentCollection_8h_source.html#l00125">Ogre::SimplePageContentCollectionFactory::destroyInstance()</a>, <a class="el" href="OgreUserObjectBindings_8h_source.html#l00116">Ogre::UserObjectBindings::Attributes::~Attributes()</a>, <a class="el" href="OgreD3D11HardwareBufferManager_8h_source.html#l00084">Ogre::D3D11HardwareBufferManager::~D3D11HardwareBufferManager()</a>, <a class="el" href="OgreD3D9HardwareBufferManager_8h_source.html#l00067">Ogre::D3D9HardwareBufferManager::~D3D9HardwareBufferManager()</a>, <a class="el" href="OgreDefaultHardwareBufferManager_8h_source.html#l00129">Ogre::DefaultHardwareBufferManager::~DefaultHardwareBufferManager()</a>, <a class="el" href="OgreGLDefaultHardwareBufferManager_8h_source.html#l00128">Ogre::GLDefaultHardwareBufferManager::~GLDefaultHardwareBufferManager()</a>, <a class="el" href="OgreGLES2DefaultHardwareBufferManager_8h_source.html#l00126">Ogre::GLES2DefaultHardwareBufferManager::~GLES2DefaultHardwareBufferManager()</a>, <a class="el" href="OgreGLES2HardwareBufferManager_8h_source.html#l00093">Ogre::GLES2HardwareBufferManager::~GLES2HardwareBufferManager()</a>, <a class="el" href="OgreGLESDefaultHardwareBufferManager_8h_source.html#l00127">Ogre::GLESDefaultHardwareBufferManager::~GLESDefaultHardwareBufferManager()</a>, <a class="el" href="OgreGLESHardwareBufferManager_8h_source.html#l00094">Ogre::GLESHardwareBufferManager::~GLESHardwareBufferManager()</a>, <a class="el" href="OgreGLHardwareBufferManager_8h_source.html#l00093">Ogre::GLHardwareBufferManager::~GLHardwareBufferManager()</a>, <a class="el" href="OgreMeshSerializer_8h_source.html#l00174">Ogre::MeshSerializer::MeshVersionData::~MeshVersionData()</a>, <a class="el" href="OgreStaticGeometry_8h_source.html#l00139">Ogre::StaticGeometry::OptimisedSubMeshGeometry::~OptimisedSubMeshGeometry()</a>, and <a class="el" href="OgreRenderQueueSortingGrouping_8h_source.html#l00498">Ogre::RenderQueueGroup::~RenderQueueGroup()</a>.</p>

</div>
</div>
<a class="anchor" id="gab9f9fa14d424036dc5881cbcb3c741e0"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_ARRAY_T" ref="gab9f9fa14d424036dc5881cbcb3c741e0" args="(ptr, T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gab9f9fa14d424036dc5881cbcb3c741e0">OGRE_DELETE_ARRAY_T</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_ARRAY_T. Category is required to be restated to ensure the matching policy is used, count and type to call destructor. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00437">437</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga25e1e9ce907fc367cc735465c940da23"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_ARRAY_T_ALIGN" ref="ga25e1e9ce907fc367cc735465c940da23" args="(ptr, T, count, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga25e1e9ce907fc367cc735465c940da23">OGRE_DELETE_ARRAY_T_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){for (size_t _b = 0; _b &lt; count; ++_b) { (ptr)[_b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_ARRAY_T_ALIGN. Category is required to be restated to ensure the matching policy is used, count and type to call destructor. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00468">468</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga3ceedc1e74432821ffab664232c12d04"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_ARRAY_T_SIMD" ref="ga3ceedc1e74432821ffab664232c12d04" args="(ptr, T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga3ceedc1e74432821ffab664232c12d04">OGRE_DELETE_ARRAY_T_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){for (size_t b = 0; b &lt; count; ++b) { (ptr)[b].~T();} ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_ARRAY_T_SIMD. Category is required to be restated to ensure the matching policy is used, count and type to call destructor. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00460">460</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga0b0974da65362dd8a14071e7f6e4daca"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_T" ref="ga0b0974da65362dd8a14071e7f6e4daca" args="(ptr, T, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga0b0974da65362dd8a14071e7f6e4daca">OGRE_DELETE_T</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_T. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00435">435</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAny_8h_source.html#l00122">Ogre::Any::destroy()</a>, and <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>.</p>

</div>
</div>
<a class="anchor" id="ga076af127ea8efe2284e03ab4c2057603"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_T_ALIGN" ref="ga076af127ea8efe2284e03ab4c2057603" args="(ptr, T, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga076af127ea8efe2284e03ab4c2057603">OGRE_DELETE_T_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_T_ALIGN. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00466">466</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga1a5d598e538371f2fca9608277051347"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_DELETE_T_SIMD" ref="ga1a5d598e538371f2fca9608277051347" args="(ptr, T, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga1a5d598e538371f2fca9608277051347">OGRE_DELETE_T_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if(ptr){(ptr)-&gt;~T(); ::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr);}</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_NEW_T_SIMD. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00458">458</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gacfd8dc937cf390c7bff05495f0dc10cf"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_FREE" ref="gacfd8dc937cf390c7bff05495f0dc10cf" args="(ptr, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gacfd8dc937cf390c7bff05495f0dc10cf">OGRE_FREE</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with OGRE_MALLOC or OGRE_ALLOC_T. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00428">428</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreSharedPtr_8h_source.html#l00223">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::destroy()</a>, <a class="el" href="OgreTerrain_8h_source.html#l00470">Ogre::Terrain::ImportData::destroy()</a>, <a class="el" href="OgreStreamSerialiser_8h_source.html#l00366">Ogre::StreamSerialiser::readConverted()</a>, <a class="el" href="OgreStreamSerialiser_8h_source.html#l00353">Ogre::StreamSerialiser::writeConverted()</a>, <a class="el" href="OgreAxisAlignedBox_8h_source.html#l00141">Ogre::AxisAlignedBox::~AxisAlignedBox()</a>, and <a class="el" href="OgreVertexIndexData_8h_source.html#l00297">Ogre::VertexCacheProfiler::~VertexCacheProfiler()</a>.</p>

</div>
</div>
<a class="anchor" id="gaa06d37a211e3da357b8457ccdb4decac"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_FREE_ALIGN" ref="gaa06d37a211e3da357b8457ccdb4decac" args="(ptr, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gaa06d37a211e3da357b8457ccdb4decac">OGRE_FREE_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::deallocateBytes((void*)ptr)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with either OGRE_MALLOC_ALIGN or OGRE_ALLOC_T_ALIGN. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00451">451</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gaf7501eb098fc6671420c628dc80af2a8"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_FREE_SIMD" ref="gaf7501eb098fc6671420c628dc80af2a8" args="(ptr, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gaf7501eb098fc6671420c628dc80af2a8">OGRE_FREE_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">ptr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::deallocateBytes((void*)ptr)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free the memory allocated with either OGRE_MALLOC_SIMD or OGRE_ALLOC_T_SIMD. Category is required to be restated to ensure the matching policy is used. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00449">449</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga2382b731c3d757f74f0fedf2b14ed9d6"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_MALLOC" ref="ga2382b731c3d757f74f0fedf2b14ed9d6" args="(bytes, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga2382b731c3d757f74f0fedf2b14ed9d6">OGRE_MALLOC</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">bytes, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(bytes)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of raw memory, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00424">424</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga876cf0a4c7e209ce798b5e6708ca2343"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_MALLOC_ALIGN" ref="ga876cf0a4c7e209ce798b5e6708ca2343" args="(bytes, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga876cf0a4c7e209ce798b5e6708ca2343">OGRE_MALLOC_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">bytes, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(bytes)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of raw memory aligned to user defined boundaries, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00443">443</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gafd7ddaef10ac9ea1ffbd18902167b9a2"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_MALLOC_SIMD" ref="gafd7ddaef10ac9ea1ffbd18902167b9a2" args="(bytes, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gafd7ddaef10ac9ea1ffbd18902167b9a2">OGRE_MALLOC_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">bytes, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(bytes)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of raw memory aligned to SIMD boundaries, and indicate the category of usage. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00441">441</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gab5fc1358fd5a889de0a06d07e45df1ff"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW" ref="gab5fc1358fd5a889de0a06d07e45df1ff" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gab5fc1358fd5a889de0a06d07e45df1ff">OGRE_NEW</a>&#160;&#160;&#160;new</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00471">471</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRenderQueueSortingGrouping_8h_source.html#l00520">Ogre::RenderQueueGroup::addRenderable()</a>, <a class="el" href="OgreShaderHLSLProgramWriter_8h_source.html#l00129">Ogre::RTShader::ShaderProgramWriterHLSLFactory::create()</a>, <a class="el" href="OgreShaderCGProgramWriter_8h_source.html#l00130">Ogre::RTShader::ShaderProgramWriterCGFactory::create()</a>, <a class="el" href="OgreShaderGLSLProgramWriter_8h_source.html#l00130">Ogre::RTShader::ShaderProgramWriterGLSLFactory::create()</a>, <a class="el" href="OgreShaderGLSLESProgramWriter_8h_source.html#l00178">Ogre::RTShader::ShaderProgramWriterGLSLESFactory::create()</a>, <a class="el" href="OgreSceneManager_8h_source.html#l00717">Ogre::SceneManager::createAutoParamDataSource()</a>, <a class="el" href="OgreZip_8h_source.html#l00117">Ogre::ZipArchiveFactory::createInstance()</a>, <a class="el" href="OgreSimplePageContentCollection_8h_source.html#l00121">Ogre::SimplePageContentCollectionFactory::createInstance()</a>, <a class="el" href="OgreFileSystem_8h_source.html#l00131">Ogre::FileSystemArchiveFactory::createInstance()</a>, <a class="el" href="OgreZip_8h_source.html#l00137">Ogre::EmbeddedZipArchiveFactory::createInstance()</a>, <a class="el" href="OgreOverlayElementFactory_8h_source.html#l00076">Ogre::PanelOverlayElementFactory::createOverlayElement()</a>, <a class="el" href="OgreOverlayElementFactory_8h_source.html#l00089">Ogre::BorderPanelOverlayElementFactory::createOverlayElement()</a>, <a class="el" href="OgreOverlayElementFactory_8h_source.html#l00102">Ogre::TextAreaOverlayElementFactory::createOverlayElement()</a>, <a class="el" href="OgreRenderQueueSortingGrouping_8h_source.html#l00687">Ogre::RenderQueueGroup::merge()</a>, and <a class="el" href="OgreTerrain_8h_source.html#l00428">Ogre::Terrain::ImportData::operator=()</a>.</p>

</div>
</div>
<a class="anchor" id="ga6c428bbdad197df6a4ba22d3c1d48f5a"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_ARRAY_T" ref="ga6c428bbdad197df6a4ba22d3c1d48f5a" args="(T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga6c428bbdad197df6a4ba22d3c1d48f5a">OGRE_NEW_ARRAY_T</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for 'count' primitive types - do not use for classes that inherit from AllocatedObject. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00433">433</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga51224b5c8af6fd85e192975ebe20139b"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_ARRAY_T_ALIGN" ref="ga51224b5c8af6fd85e192975ebe20139b" args="(T, count, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga51224b5c8af6fd85e192975ebe20139b">OGRE_NEW_ARRAY_T_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T)*(count))), count)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for 'count' primitive types aligned to user defined boundaries - do not use for classes that inherit from AllocatedObject. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00464">464</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="gaa55846bae98cf66fd5158ad0d4d623bb"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_ARRAY_T_SIMD" ref="gaa55846bae98cf66fd5158ad0d4d623bb" args="(T, count, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#gaa55846bae98cf66fd5158ad0d4d623bb">OGRE_NEW_ARRAY_T_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">count, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;::<a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a>(static_cast&lt;T*&gt;(::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T)*(count))), count)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate a block of memory for 'count' primitive types aligned to SIMD boundaries - do not use for classes that inherit from AllocatedObject. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00456">456</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga46253f12658ce0922e982a8a9dd11312"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_T" ref="ga46253f12658ce0922e982a8a9dd11312" args="(T, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga46253f12658ce0922e982a8a9dd11312">OGRE_NEW_T</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAllocPolicy.html">Ogre::CategorisedAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T))) T</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate space for one primitive type, external type or non-virtual type with constructor parameters. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00431">431</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAny_8h_source.html#l00283">Ogre::AnyNumeric::numholder&lt; ValueType &gt;::add()</a>, <a class="el" href="OgreAny_8h_source.html#l00234">Ogre::AnyNumeric::AnyNumeric()</a>, <a class="el" href="OgreSharedPtr_8h_source.html#l00167">Ogre::SharedPtr&lt; D3D11GpuProgram &gt;::bind()</a>, <a class="el" href="OgreAny_8h_source.html#l00165">Ogre::Any::holder&lt; ValueType &gt;::clone()</a>, <a class="el" href="OgreAny_8h_source.html#l00278">Ogre::AnyNumeric::numholder&lt; ValueType &gt;::clone()</a>, <a class="el" href="OgreAny_8h_source.html#l00299">Ogre::AnyNumeric::numholder&lt; ValueType &gt;::divide()</a>, <a class="el" href="OgreAny_8h_source.html#l00291">Ogre::AnyNumeric::numholder&lt; ValueType &gt;::multiply()</a>, and <a class="el" href="OgreAny_8h_source.html#l00287">Ogre::AnyNumeric::numholder&lt; ValueType &gt;::subtract()</a>.</p>

</div>
</div>
<a class="anchor" id="ga4c928813aac2c96ae5cc775aacd3e26d"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_T_ALIGN" ref="ga4c928813aac2c96ae5cc775aacd3e26d" args="(T, category, align)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga4c928813aac2c96ae5cc775aacd3e26d">OGRE_NEW_T_ALIGN</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">align&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category, align&gt;::allocateBytes(sizeof(T))) T</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate space for one primitive type, external type or non-virtual type aligned to user defined boundaries. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00462">462</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga2f7eef98b7fe3ba9f36630b787d603b1"></a><!-- doxytag: member="OgreMemoryAllocatorConfig.h::OGRE_NEW_T_SIMD" ref="ga2f7eef98b7fe3ba9f36630b787d603b1" args="(T, category)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define <a class="el" href="group__Memory.html#ga2f7eef98b7fe3ba9f36630b787d603b1">OGRE_NEW_T_SIMD</a></td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">T, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">category&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;new (::<a class="el" href="classOgre_1_1CategorisedAlignAllocPolicy.html">Ogre::CategorisedAlignAllocPolicy</a>&lt;category&gt;::allocateBytes(sizeof(T))) T</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Allocate space for one primitive type, external type or non-virtual type aligned to SIMD boundaries. </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00454">454</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<hr/><h2>Enumeration Type Documentation</h2>
<a class="anchor" id="ga830fab51be174d6f2849857cb1abb36a"></a><!-- doxytag: member="Ogre::MemoryCategory" ref="ga830fab51be174d6f2849857cb1abb36a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="group__Memory.html#ga830fab51be174d6f2849857cb1abb36a">Ogre::MemoryCategory</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A set of categories that indicate the purpose of a chunk of memory being allocated. </p>
<p>These categories will be provided at allocation time in order to allow the allocation policy to vary its behaviour if it wishes. This allows you to use a single policy but still have variant behaviour. The level of control it gives you is at a higher level than assigning different policies to different classes, but is the only control you have over general allocations that are primitive types. </p>
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb"></a><!-- doxytag: member="MEMCATEGORY_GENERAL" ref="gga830fab51be174d6f2849857cb1abb36aa8ac29a2852b1b5fe79d1659b16f521cb" args="" -->MEMCATEGORY_GENERAL</em>&nbsp;</td><td>
<p>General purpose. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e"></a><!-- doxytag: member="MEMCATEGORY_GEOMETRY" ref="gga830fab51be174d6f2849857cb1abb36aaf9e04ff475de4493bc942a9c73da4c2e" args="" -->MEMCATEGORY_GEOMETRY</em>&nbsp;</td><td>
<p>Geometry held in main memory. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa24267bedbd1115a8f208e4ee355693e4"></a><!-- doxytag: member="MEMCATEGORY_ANIMATION" ref="gga830fab51be174d6f2849857cb1abb36aa24267bedbd1115a8f208e4ee355693e4" args="" -->MEMCATEGORY_ANIMATION</em>&nbsp;</td><td>
<p><a class="el" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> data like tracks, bone matrices. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90"></a><!-- doxytag: member="MEMCATEGORY_SCENE_CONTROL" ref="gga830fab51be174d6f2849857cb1abb36aa8a55fa0fcaa8403bb51ca210f882ed90" args="" -->MEMCATEGORY_SCENE_CONTROL</em>&nbsp;</td><td>
<p>Nodes, control data. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aaffe1e3d51d961175f8f2756611439181"></a><!-- doxytag: member="MEMCATEGORY_SCENE_OBJECTS" ref="gga830fab51be174d6f2849857cb1abb36aaffe1e3d51d961175f8f2756611439181" args="" -->MEMCATEGORY_SCENE_OBJECTS</em>&nbsp;</td><td>
<p>Scene object instances. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa04bad2e7f64cc2b6f4cda9f56b59e5b4"></a><!-- doxytag: member="MEMCATEGORY_RESOURCE" ref="gga830fab51be174d6f2849857cb1abb36aa04bad2e7f64cc2b6f4cda9f56b59e5b4" args="" -->MEMCATEGORY_RESOURCE</em>&nbsp;</td><td>
<p>Other resources. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aaa037d2f843117cd5fb39ec064d7ff23b"></a><!-- doxytag: member="MEMCATEGORY_SCRIPTING" ref="gga830fab51be174d6f2849857cb1abb36aaa037d2f843117cd5fb39ec064d7ff23b" args="" -->MEMCATEGORY_SCRIPTING</em>&nbsp;</td><td>
<p>Scripting. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa29274489311d683a88676dbb1c779788"></a><!-- doxytag: member="MEMCATEGORY_RENDERSYS" ref="gga830fab51be174d6f2849857cb1abb36aa29274489311d683a88676dbb1c779788" args="" -->MEMCATEGORY_RENDERSYS</em>&nbsp;</td><td>
<p>Rendersystem structures. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="gga830fab51be174d6f2849857cb1abb36aa4ff2b9446477e2ea4170b09d8aaa1b67"></a><!-- doxytag: member="MEMCATEGORY_COUNT" ref="gga830fab51be174d6f2849857cb1abb36aa4ff2b9446477e2ea4170b09d8aaa1b67" args="" -->MEMCATEGORY_COUNT</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00158">158</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="gae542663b49eb68a74336d84e11ba0b9c"></a><!-- doxytag: member="Ogre::constructN" ref="gae542663b49eb68a74336d84e11ba0b9c" args="(T *basePtr, size_t count)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* <a class="el" href="group__Memory.html#gae542663b49eb68a74336d84e11ba0b9c">Ogre::constructN</a> </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>basePtr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>count</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Utility function for constructing an array of objects with placement new, without using new[] (which allocates an undocumented amount of extra memory and so isn't appropriate for custom allocators). </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html#l00344">344</a> of file <a class="el" href="OgreMemoryAllocatorConfig_8h_source.html">OgreMemoryAllocatorConfig.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga34a9308dc656f694883718bf8fa4f1c2"></a><!-- doxytag: member="Ogre::operator!=" ref="ga34a9308dc656f694883718bf8fa4f1c2" args="(STLAllocator&lt; T, P &gt; const &amp;, STLAllocator&lt; T2, P &gt; const &amp;)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename T2 , typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::operator!= </td>
          <td>(</td>
          <td class="paramtype">STLAllocator&lt; T, P &gt; const &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">STLAllocator&lt; T2, P &gt; const &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>determine equality, can memory from another allocator be released by this allocator, (ISO C++) </p>

<p>Definition at line <a class="el" href="OgreMemorySTLAllocator_8h_source.html#l00201">201</a> of file <a class="el" href="OgreMemorySTLAllocator_8h_source.html">OgreMemorySTLAllocator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ga0cec9339a4ab3eaf48c767087cd7f400"></a><!-- doxytag: member="Ogre::operator!=" ref="ga0cec9339a4ab3eaf48c767087cd7f400" args="(STLAllocator&lt; T, P &gt; const &amp;, OtherAllocator const &amp;)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename P , typename OtherAllocator &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::operator!= </td>
          <td>(</td>
          <td class="paramtype">STLAllocator&lt; T, P &gt; const &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">OtherAllocator const &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>determine equality, can memory from another allocator be released by this allocator, (ISO C++) </p>

<p>Definition at line <a class="el" href="OgreMemorySTLAllocator_8h_source.html#l00211">211</a> of file <a class="el" href="OgreMemorySTLAllocator_8h_source.html">OgreMemorySTLAllocator.h</a>.</p>

</div>
</div>
<a class="anchor" id="gaa5b83b2ba3ce965e3d8dd129c93ee43b"></a><!-- doxytag: member="Ogre::operator==" ref="gaa5b83b2ba3ce965e3d8dd129c93ee43b" args="(STLAllocator&lt; T, P &gt; const &amp;, STLAllocator&lt; T2, P &gt; const &amp;)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename T2 , typename P &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::operator== </td>
          <td>(</td>
          <td class="paramtype">STLAllocator&lt; T, P &gt; const &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">STLAllocator&lt; T2, P &gt; const &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>determine equality, can memory from another allocator be released by this allocator, (ISO C++) </p>

<p>Definition at line <a class="el" href="OgreMemorySTLAllocator_8h_source.html#l00183">183</a> of file <a class="el" href="OgreMemorySTLAllocator_8h_source.html">OgreMemorySTLAllocator.h</a>.</p>

<p>Referenced by <a class="el" href="OgreDualQuaternion_8h_source.html#l00117">Ogre::DualQuaternion::operator!=()</a>, <a class="el" href="OgreMatrix3_8h_source.html#l00140">Ogre::Matrix3::operator!=()</a>, and <a class="el" href="OgreQuaternion_8h_source.html#l00192">Ogre::Quaternion::operator!=()</a>.</p>

</div>
</div>
<a class="anchor" id="gaa34a630f2287087875d360c454a0fb48"></a><!-- doxytag: member="Ogre::operator==" ref="gaa34a630f2287087875d360c454a0fb48" args="(STLAllocator&lt; T, P &gt; const &amp;, OtherAllocator const &amp;)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename P , typename OtherAllocator &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::operator== </td>
          <td>(</td>
          <td class="paramtype">STLAllocator&lt; T, P &gt; const &amp;&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">OtherAllocator const &amp;&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>determine equality, can memory from another allocator be released by this allocator, (ISO C++) </p>

<p>Definition at line <a class="el" href="OgreMemorySTLAllocator_8h_source.html#l00193">193</a> of file <a class="el" href="OgreMemorySTLAllocator_8h_source.html">OgreMemorySTLAllocator.h</a>.</p>

</div>
</div>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
